%Vector of network ODEs for Infector Detector assuming energy dependence,
%which is modelled by the Hill-function

function dxdt=ID_EnergyODE(t,x)

global k1 k2 k3 k4 k5 k6 Ka Kb Ke n Po deg_x1 deg_x2 deg_x6 alpha1 alpha2;

x1 = x(1); %[LuxR]
x2 = x(2); %[AHL]
x3 = x(3); %[A]
x4 = x(4); %[P]
x5 = x(5); %[AP]
x6 = x(6); %[FP]
x7 = x(7); %[E]

%Network ODEs
dx1dt = k1*(x7^n/(Ke^n + x7^n)) + (k3*x3) - (k2*x1.*x2) - deg_x1*x1;
dx2dt = (k3*x3) - (k2*x1.*x2) -(deg_x2)*x2 ;
dx3dt = -k3*x3 + (k2*x1.*x2)- k4*x3.*x4 + k5*x5;
dx4dt = -k4*x3.*x4 + k5*x5;
dx5dt = k4*x3.*x4 - k5*x5;
dx6dt = k6*x5*(x7^n/(Ke^n + x7^n)) - deg_x6*x6;
dx7dt = -(k1*alpha1 + k6*alpha2.*x5).*(x7^n/(Ke^n + x7^n));


dxdt=[dx1dt; dx2dt; dx3dt; dx4dt; dx5dt; dx6dt; dx7dt];



