%Original system of equation, modified by introduction of Hill-like 
%energy dependence

close all; clear; clc;

global k1 k2 k3 k4 k5 k6 Ke n Po deg_x1 deg_x2 deg_x6 alpha1 alpha2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Initial Concentration of Promoters
Po= 5;  

%Rate constants
k1 = 0.3;   % k1 = 0.01 for C1, take k1 = 0 for C2 
k2 = 100;  k3 = 100; 
k4 = 100;  k5 = 100;
k6 = 20*k1;

% half-saturation coefficient for "Energy" Hill-function
Ke = 20; % Ke = 1?

% + co-operativity coeff - representation of degree of E-dependence
n=2; 

%Coefficients associated with gene transcription - ptet & gfp
alpha1 = 1;
alpha2 = 0.9;

%Degradation Terms in min-1
deg_x1 = 0;
deg_x2 = 0;
deg_x6 = 0.0005; % deg_GFP

% Initial Energy in System (initial conc. of nutrient medium)
Eo = 8; 

% Defining Time Span (in minutes)
tmax = 300;
tstep = 0.1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Initial conditions

LuxR_0 = 0;
AHL_0 =  5;

out1 = [];

Po= [0 0.1 0.25 0.5 0.75 1 5 10 50]; 

   
for P_0 = Po
    
  k1 = P_0*0.3;
  k6 = P_0*20*k1;

  [t,x] = ode15s('ID_EnergyODE',[0:tstep:tmax],[LuxR_0; AHL_0; 0; P_0; 0; 0; Eo]);
 
  final = x(:, 6);
  out1 = [out1 final];
  
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%Plots
figure(2);
plot(t, out1(:,1), t, out1(:,2), t, out1(:,3), t, out1(:,4), t, out1(:,5),t, out1(:,6),t, out1(:,7));
xlabel('time (min)','fontweight','b')
ylabel(['[Energy] (a.u.)'],'fontweight','b')
title('Construct 1 - varying [P]_0 - a representation of varying initial [DNA]','fontsize',14,'fontweight','b')
% legend('[P]_0 = 0', '[P]_0 = 1', '[P]_0 = 5', '[P]_0 = 50', '[P]_0 = 100');










  
