%Original system of equation, modified by introduction of Hill-like 
%energy dependence

close all; clear; clc;

global k1 k2 k3 k4 k5 k6 Ke n Po deg_x1 deg_x2 deg_x6 alpha1 alpha2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Initial Concentration of Promoters
Po= 5;  

%Rate constants
k1 = 0.3;   % k1 = 0.01 for C1, take k1 = 0 for C2 
k2 = 100;  k3 = 100; 
k4 = 100;  k5 = 100;
k6 = 20*k1;

% half-saturation coefficient for "Energy" Hill-function
Ke = 20; 

% + co-operativity coeff - representation of degree of E-dependence
n=2; 

%Coefficients associated with gene transcription - ptet & gfp
alpha1 = 1;
alpha2 = 0.9;

%Degradation Terms in min-1
deg_x1 = 0;)
deg_x2 = 0;
deg_x6 = 0.0005; % deg_GFP

% Initial Energy in System (initial conc. of nutrient medium)
Eo = 8; 

% Defining Time Span (in minutes)
tmax = 300;
tstep = 0.1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
LuxR_0 = 0;

out1 = [];
ahl_01 = [];

%Sending all these parameters to ODE solver
   
for i = 1:0.1:10

  currentAHL_0 = 10^(i-5);  % current [AHL]0
  ahl_01 = [ahl_01 currentAHL_0]; % store each instance of [AHL]0 in variable ahl_0 

  [t,x] = ode15s('ID_EnergyODE',[0:tstep:tmax],[LuxR_0; currentAHL_0; 0; Po; 0; 0; Eo]); 
 
  final = x(end, 6); %x6 = GFP; x7 = E
  out1 = [out1 final];
  
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Plots
figure(2);
semilogx(ahl_01, out1, 'r-'), grid;
xlabel('[AHL]','fontweight','b')
ylabel(['[GFP] after t =  ' num2str(tmax) ' min'],'fontweight','b')
title('Construct 1  Transfer Function','fontsize',14,'fontweight','b')
% legend('construct 1','construct 2')









  
